--- ..\sip-snapshot-20050430\sipconfig.py	2005-05-03 15:06:46.539558800 +0200
+++ sipconfig.py	2005-05-03 15:16:01.285495600 +0200
@@ -126,6 +126,7 @@
     'MAKEFILE_GENERATOR':       'MSVC.NET',
     'MKDIR':                    'mkdir',
     'MOC':                      'd:\\qt-334\\\\bin\\moc.exe',
+    'PCHFLAGS':                 '-Yupch.cpp -FIpch.cpp -Fppch.pch',
     'RANLIB':                   '',
     'RPATH':                    '',
     'STRIP':                    ''
@@ -811,6 +812,7 @@
 
         self.generate_macros_and_rules(mfile)
         self.generate_target_default(mfile)
+        self.generate_target_pch(mfile, mfname)
         self.generate_target_install(mfile)
 
         if self._installs:
@@ -846,6 +848,7 @@
         mfile.write("CFLAGS = %s\n" % self.optional_string("CFLAGS"))
         mfile.write("CXXFLAGS = %s\n" % self.optional_string("CXXFLAGS"))
         mfile.write("LFLAGS = %s\n" % self.optional_string("LFLAGS"))
+        mfile.write("PCHFLAGS = %s\n" % self.optional_string("PCHFLAGS"))
 
         libs = []
 
@@ -875,22 +878,22 @@
         if self.generator in ("MSVC", "MSVC.NET"):
             mfile.write("""
 {.}.cpp{}.obj::
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -Fo @<<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -Fo @<<
 \t$<
 <<
 
 {.}.cc{}.obj::
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -Fo @<<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -Fo @<<
 \t$<
 <<
 
 {.}.cxx{}.obj::
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -Fo @<<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -Fo @<<
 \t$<
 <<
 
 {.}.C{}.obj::
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -Fo @<<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -Fo @<<
 \t$<
 <<
 
@@ -902,19 +905,19 @@
         elif self.generator == "BMAKE":
             mfile.write("""
 .cpp.obj:
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -o$@ $<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -o$@ $<
 
 .cc.obj:
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -o$@ $<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -o$@ $<
 
 .cxx.obj:
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -o$@ $<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -o$@ $<
 
 .C.obj:
-\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -o$@ $<
+\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) $(PCHFLAGS) -o$@ $<
 
 .c.obj:
-\t$(CC) -c $(CFLAGS) $(CPPFLAGS) -o$@ $<
+\t$(CC) -c $(CFLAGS) $(CPPFLAGS) $(PCHFLAGS) -o$@ $<
 """)
         else:
             mfile.write("""
@@ -955,6 +958,13 @@
         """
         mfile.write("\nclean:\n")
 
+    def generate_target_pch(self, mfile, mfname):
+        """The default implementation of the PCH target.
+
+        mfile is the file object. mfname is the full path name of the
+        Makefile."""
+        mfile.write("\npch:\n")
+
     def install_file(self, mfile, src, dst, strip=0):
         """Install one or more files in a directory.
 
@@ -1278,7 +1288,7 @@
 
         mfile is the file object.
         """
-        mfile.write("\n$(TARGET): $(OFILES)\n")
+        mfile.write("\n$(TARGET): pch $(OFILES)\n")
 
         if self.generator in ("MSVC", "MSVC.NET"):
             if self.static:
@@ -1378,6 +1388,30 @@
         if self._export_init and (sys.platform[:5] == 'linux' or sys.platform[:3] == 'aix'):
             mfile.write("\t-%s %s.exp\n" % (self.rm, self._target))
 
+    def generate_target_pch(self, mfile, mfname):
+        """Generate the pch target.
+
+        mfile is the file object. mfname is the full path name of the Makefile.
+        """
+        pchname = os.path.join(os.path.split(mfname)[0], "pch.cpp")
+        try:
+            pch = open(pchname, "w")
+        except IOError, detail:
+            error("Unable to create \"%s\": %s" % (pchname, detail))
+
+        for h in self._build["headers"].split():
+            print >>pch, '#include "%s"' % h
+
+        pch.close()
+
+        if self.generator in ("MSVC", "MSVC.NET", "BMAKE"):
+            ext = ".obj"
+        else:
+            ext = ".o"
+
+        mfile.write("\npch: pch.pch\n")
+        mfile.write("pch.pch: pch.cpp $(HFILES)\n")
+        mfile.write("\t$(CXX) -c $(CXXFLAGS) $(CPPFLAGS) -Fppch.pch -Yc pch.cpp\n")
 
 class SIPModuleMakefile(ModuleMakefile):
     """The class that represents a SIP generated module Makefile.
